#![no_std]
#![no_main]

use crate::utils::clear_bss;
use core::arch::global_asm;

mod console;
mod sbi;
mod sync;
mod syscall;
mod trap;
mod utils;
mod loader;
mod boards;
mod config;
mod task;
mod timer;

global_asm!(include_str!("entry.asm"));
global_asm!(include_str!("link_app.asm"));

#[no_mangle]
fn rust_main() -> ! {
    clear_bss();
    log_information!("[kernel] Hello, rCore!");
    trap::init();
    loader::load_apps();
    task::run_first_task();

    unreachable!()
}
